// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};

void solve() {
	int n, m, k;
	cin >> n >> m >> k;
	int sx, sy, tx, ty;
	vector<vector<int>> field(n, vector<int>(m));
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < m; ++j) {
			if (s[j] == '#') {
				field[i][j] = 1;
			}
			if (s[j] == 'S') {
				sx = i;
				sy = j;
			}
			if (s[j] == 'F') {
				tx = i;
				ty = j;
			}
		}
	}

	vector<pair<pii, int>> vars;
	vars.push_back({{sx, sy}, 0});

	vector<vector<int>> dist(n, vector<int>(m));

	auto bfs = [&](int x, int y) {
		for (auto& v : dist) {
			fill(v.begin(), v.end(), INF);
		}
		dist[x][y] = 0;
		queue<pii> qu;
		qu.push({x, y});
		while (szof(qu)) {
			auto [cx, cy] = qu.front();
			qu.pop();

			for (int d = 0; d < 4; ++d) {
				int nx = cx + dx[d];
				int ny = cy + dy[d];
				if (0 <= nx && nx < n && 0 <= ny && ny < m && !field[nx][ny] && dist[nx][ny] > dist[cx][cy] + 1) {
					dist[nx][ny] = dist[cx][cy] + 1;
					qu.push({nx, ny});
				}
			}
		}
	};

	for (int i = 0; i < k; ++i) {
		int x, y;
		cin >> x >> y;
		--x; --y;
		vector<int> best_next(4, INF);
		for (auto p : vars) {
			bfs(p.ff.ff, p.ff.ss);
			for (int d = 0; d < 4; ++d) {
				int nx = x + dx[d];
				int ny = y + dy[d];
				if (0 <= nx && nx < n && 0 <= ny && ny < m && !field[nx][ny]) {
					best_next[d] = min(p.ss + dist[nx][ny], best_next[d]);
				}
			}
		}

		vars.clear();
		for (int d = 0; d < 4; ++d) {
			if (best_next[d] < INF) {
				vars.push_back({{x + dx[d], y + dy[d]}, best_next[d]});
			}
		}

		sort(vars.begin(), vars.end(), [&](auto& a, auto& b) {
			return a.ss < b.ss;
		});
		while (szof(vars) && vars.back().ss != vars.front().ss) {
			vars.pop_back();
		}
	}

	int ans = INF;
	for (auto p : vars) {
		bfs(p.ff.ff, p.ff.ss);
		ans = min(ans, p.ss + dist[tx][ty]);
	}

	if (ans == INF) {
		cout << "-1\n";
	} else {
		cout << ans << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}