// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;


int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n, m;
	cin >> n >> m;
	vector<vector<int>> field(n, vector<int>(m));

	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < m; ++j) {
			field[i][j] = s[j] != '.';
		}
	}

	vector<vector<int>> nodes(n, vector<int>(m, -1));
	int cnt_nodes = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (field[i][j]) {
				nodes[i][j] = cnt_nodes++;
			}
		}
	}

	vector<vector<int>> graph(cnt_nodes);

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (field[i][j]) {
				if (i == 0 || !field[i - 1][j]) {
					int k = i;
					vector<int> cur_nodes;
					while (k < n && field[k][j]) {
						cur_nodes.push_back(nodes[k][j]);
						++k;
					}
					for (int k = 0; k < szof(cur_nodes) - 1 - k; ++k) {
						int a = cur_nodes[k];
						int b = cur_nodes[szof(cur_nodes) - 1 - k];
						graph[a].push_back(b);
						graph[b].push_back(a);
					}
				}
				if (j == 0 || !field[i][j - 1]) {
					int k = j;
					vector<int> cur_nodes;
					while (k < m && field[i][k]) {
						cur_nodes.push_back(nodes[i][k]);
						++k;
					}
					for (int k = 0; k < szof(cur_nodes) - 1 - k; ++k) {
						int a = cur_nodes[k];
						int b = cur_nodes[szof(cur_nodes) - 1 - k];
						graph[a].push_back(b);
						graph[b].push_back(a);
					}
				}
			}
		}
	}

	vector<bool> used(cnt_nodes);
	vector<int> color(cnt_nodes);

	function<void(int, int)> dfs = [&](int v, int col) {
		color[v] = col;
		used[v] = true;
		for (int to : graph[v]) {
			if (!used[to]) {
				dfs(to, 1 - col);
			} else {
				assert(color[to] != col);
			}
		}
	};

	for (int i = 0; i < cnt_nodes; ++i) {
		if (!used[i]) {
			dfs(i, 0);
		}
	}

	cout << n << " " << m << "\n";

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (!field[i][j]) {
				cout << ".";
			} else {
				cout << "09"[color[nodes[i][j]]];
			}
		}
		cout << "\n";
	}

	return 0;
}