// Checker created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

bool is_palindrome(string s) {
	for (int i = 0; i < szof(s) - 1 - i; ++i) {
		if (s[i] != s[szof(s) - 1 - i]) {
			return false;
		}
	}
	return true;
}

int main(int argc, char* argv[]) {
	setName("compare two outputs");
	registerTestlibCmd(argc, argv);

	int n = inf.readInt();
	int m = inf.readInt();
	vector<vector<char>> field(n, vector<char>(m));
	for (int i = 0; i < n; ++i) {
		string s = inf.readToken();
		for (int j = 0; j < m; ++j) {
			field[i][j] = s[j];
		}
	}

	auto check_outp = [&](auto& stream) {
		int res = 0;
		vector<vector<char>> cur_field(n, vector<char>(m));
		for (int i = 0; i < n; ++i) {
			string s = stream.readLine(format("[0-9.]{%d}", m));
			for (int j = 0; j < m; ++j) {
				stream.ensuref((field[i][j] == '.') == (s[j] == '.'), "output should contain dots on the same places as input");
				if (s[j] != '.') {
					res += abs((int) (s[j] - '0') - (field[i][j] - '0'));
				}
				cur_field[i][j] = s[j];
			}
		}

		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				if (cur_field[i][j] == '.') {
					continue;
				}
				if (i == 0 || cur_field[i - 1][j] == '.') {
					int k = i;
					string cur_word = "";
					while (k < n && cur_field[k][j] != '.') {
						cur_word += cur_field[k][j];
						++k;
					}
					stream.ensuref(is_palindrome(cur_word), "vertical word in column #%d starting in row #%d is not a palindrome", j + 1, i + 1);
				}
				if (j == 0 || cur_field[i][j - 1] == '.') {
					int k = j;
					string cur_word = "";
					while (k < m && cur_field[i][k] != '.') {
						cur_word += cur_field[i][k];
						++k;
					}
					stream.ensuref(is_palindrome(cur_word), "horizontal word in row #%d starting in column #%d is not a palindrome", i + 1, j + 1);
				}
			}
		}

		return res;
	};

	int jans = check_outp(ans);
	int pans = check_outp(ouf);

	if (jans < pans) {
		quitf(_wa, "participant found answer with cost %d, but jury did it with cost %d", pans, jans);
	}

	if (pans < jans) {
		quitf(_fail, "jury found answer with cost %d, but participant did it with cost %d", jans, pans);
	}

	quitf(_ok, "participant found answer with cost %d", pans);

	return 0;
}