#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int cur_test = -1;
const int MAXN = 1e5;

map<string, int> SI = {
    {"tera", 12},  
    {"giga" , 9},   
    {"mega" , 6},  
    {"kilo" , 3},  
    {"deci" , -1}, 
    {"centi", -2}, 
    {"milli", -3}, 
    {"micro", -6}, 
    {"nano" , -9} 
};

void write_test(string s) 
{
    startTest(cur_test++);
    cerr << cur_test << endl;
    cout << s << endl;
}

vector<string> prefs;

void gen1group()
{
    for (auto s : prefs)
    {
        write_test(s + "meter");
        write_test(s + "meter^2");
        write_test(s + "meter^3");
    }
}

void gen_rand(int maxn, int p = 1)
{
    string end = "meter";
    if (p > 1)
        end += "^" + to_string(p);
    maxn -= end.size();
    string s = "";
    while (int(s.size()) + 5 <= maxn)
    {
        int i = rnd.next(prefs.size());
        s += prefs[i];    
    }
    write_test(s + end);
}

void gen_equal(int maxn, string pref, int p = 1)
{
    string end = "meter";
    if (p > 1)
        end += "^" + to_string(p);
    maxn -= end.size();
    string s = "";
    while (int(s.size()) + 5 <= maxn)
    {
        s += pref;    
    }
    write_test(s + end);
}


int main(int argc, char * argv[]) 
{
    string all = "";
    for (auto p : SI)
        all += p.first, prefs.push_back(p.first);
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);
    gen1group();
    cerr << format("2nd group starts from test %d", cur_test) << endl;
    write_test(all + "meter");
    for (int i = 40; i <= MAXN; i *= 10)
    {
        gen_rand(rnd.next(i/2, i));
        gen_rand(i);
        gen_equal(rnd.next(i/2, i), prefs[rnd.next(prefs.size())]);
        gen_equal(i, "tera");
        gen_equal(i, "nano");

        if (i == 40)
            i = 10;
    }
    cerr << format("3rd group starts from test %d", cur_test) << endl;
    write_test(all + "meter^2");
    write_test(all + "meter^3");
    for (int i = 40; i <= MAXN; i *= 10)
    {
        gen_rand(rnd.next(i/2, i), rnd.next(2, 3));
        gen_rand(i, rnd.next(2, 3));
        gen_equal(rnd.next(i/2, i), prefs[rnd.next(prefs.size())], rnd.next(2, 3));
        gen_equal(i, "tera", 2);
        gen_equal(i, "nano", 2);
        gen_equal(i, "tera", 3);
        gen_equal(i, "nano", 3);
        if (i == 40)
            i = 10;
    }
    return 0;
}
